datablock AudioProfile(idfdefenderfireSound)
{
   filename    = "./sounds/fire.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(idfdefendersilencedSound)
{
   filename    = "./sounds/firesil.wav";
   description = AudioClose3d;
   preload = true;
};

datablock AudioProfile(idfdefendercockSound)
{
   filename    = "./sounds/cock.wav";
   description = AudioClose3d;
   preload = true;
};

datablock DebrisData(idfdefenderShellDebris)
{
	shapeFile = "./models/shell.dts";
	lifetime = 2.0;
	minSpinSpeed = -400.0;
	maxSpinSpeed = 200.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 3;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 2;
};

datablock ParticleData(idfdefenderFlashParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 25;
	lifetimeVarianceMS   = 15;
	textureName          = "base/data/particles/star1";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "1.0 1.0 1.0 1.0";
	colors[1]     = "0.5 0.5 0.5 0.5";
	sizes[0]      = 0.5;
	sizes[1]      = 1.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(idfdefenderFlashEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "idfdefenderFlashParticle";
};

AddDamageType("idfdefender",   '<bitmap:add-ons/weapon_idfdefender/CI> %1',    '%2 <bitmap:add-ons/weapon_idfdefender/CI> %1',0.2,1);
datablock ProjectileData(idfdefenderProjectile)
{
   projectileShapeName = "add-ons/weapon_gun/bullet.dts";
   directDamage        = 18;
   directDamageType    = $DamageType::idfdefender;
   radiusDamageType    = $DamageType::idfdefender;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 400;
   verticalImpulse	  = 400;
   explosion           = gunExplosion;
   particleEmitter     = ""; //bulletTrailEmitter;

   muzzleVelocity      = 90;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

};

datablock ItemData(idfdefenderItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./models/galil.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "IMI Galil";
	iconName = "./icon";
	doColorShift = false;
	colorShiftColor = "0.25 0.25 0.25 1.000";

	 // Dynamic properties defined by the scripts
	image = idfdefenderImage;
	canDrop = true;
};

datablock ShapeBaseImageData(idfdefenderImage)
{
   shapeFile = "./models/galil.dts";
   emap = true;

   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   correctMuzzleVector = true;

   className = "WeaponImage";

   item = BowItem;
   ammo = " ";
   projectile = idfdefenderProjectile;
   projectileType = Projectile;

	casing = idfdefenderShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   melee = true;
   armReady = true;

   doColorShift = false;
   colorShiftColor = idfdefenderItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.15;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSound[0]					= idfdefenderCockSound;
	stateSequence[0]                = "Fire";
	stateScript[0]                  = "onStart";

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;
	stateSequence[1]	= "Ready";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Smoke";
	stateTimeoutValue[2]            = 0.05;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
	stateEmitter[2]					= idfdefenderFlashEmitter;
	stateEmitterTime[2]				= 0.09;
	stateEmitterNode[2]				= "muzzleNode";
	stateSound[2]					= idfdefenderFireSound;
	stateEjectShell[2]       = true;

	stateName[3] = "Smoke";
	stateEmitter[3]					= GunSmokeEmitter;
	stateEmitterTime[3]				= 0.00;
	stateEmitterNode[3]				= "muzzleNode";
	stateTimeoutValue[3]            = 0.03;
	stateTransitionOnTimeout[3]     = "Ready";

};

datablock ShapeBaseImageData(idfdefender2Image)
{
   shapeFile = "./models/galilsilenced.dts";
   emap = true;

   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   correctMuzzleVector = true;

   className = "WeaponImage";

   item = BowItem;
   ammo = " ";
   projectile = idfdefenderProjectile;
   projectileType = Projectile;

	casing = idfdefenderShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   melee = true;
   armReady = true;

   doColorShift = false;
   colorShiftColor = idfdefenderItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.15;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSound[0]					= idfdefenderCockSound;
	stateSequence[0]                = "Fire";
	stateScript[0]                  = "onStart";

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;
	stateSequence[1]	= "Ready";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Smoke";
	stateTimeoutValue[2]            = 0.05;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
	stateEmitter[2]					= gunSmokeEmitter;
	stateEmitterTime[2]				= 0.09;
	stateEmitterNode[2]				= "muzzleNode";
	stateSound[2]					= idfdefendersilencedSound;
	stateEjectShell[2]       = true;

	stateName[3] = "Smoke";
	stateEmitter[3]					= GunSmokeEmitter;
	stateEmitterTime[3]				= 0.00;
	stateEmitterNode[3]				= "muzzleNode";
	stateTimeoutValue[3]            = 0.03;
	stateTransitionOnTimeout[3]     = "Ready";

};

function idfdefenderImage::onStart(%this,%obj,%slot)
{
	%obj.playThread(2, plant);	
}

function idfdefenderImage::onFire(%this,%obj,%slot)
{
	if(%obj.getDamagePercent() < 1.0)
		%obj.playThread(2, plant);
	%projectile = %this.projectile;
	%spread = 0.0020;
	%shellcount = 1;

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
	return %p;
}

function idfdefender2Image::onStart(%this,%obj,%slot)
{
	%obj.playThread(2, plant);	
}

function idfdefender2Image::onFire(%this,%obj,%slot)
{
	if(%obj.getDamagePercent() < 1.0)
		%obj.playThread(2, plant);
	%projectile = %this.projectile;
	%spread = 0.0020;
	%shellcount = 1;

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
	return %p;
}

package idfimageswitch
{
  	function Armor::onTrigger(%this, %player, %slot, %val)
	{
		if(%player.getMountedImage(0) $= idfdefenderImage.getID() && %slot $= 4 && %val)
		{
		  %player.mountImage(idfdefender2Image,0);
		}     
		
		else if(%player.getMountedImage(0) $= idfdefender2image.getID() && %slot $= 4 && %val)
		{
		  %player.mountImage(idfdefenderimage,0);
		}
		Parent::onTrigger(%this, %player, %slot, %val);
	}
	function servercmdDropTool(%client,%slot)
	{
		if(%client.player.getMountedImage(0) $= idfdefender2image.getID())
		{
		  %client.player.unmountImage(0);
		}
		return Parent::servercmdDropTool(%client,%slot);
	}
};	
ActivatePackage(idfimageswitch);	